Current version
-------------
* update Portuguese resources
- fixed compatibility with TLargeIntField
- [server] fixed bug with threads in client
+ added some dbxdatabase properties
- fixed bug with DefaultPath in XLS export
 

version 3.23
-------------
+ added save to stream possibility in Jpeg, Gif, Tiff, Bmp exports
+ added new control for page headers/footers mode selection in RTF export dialog
+ added new property TfrxRTFExport.HeaderFooterMode 
  (you can select between hfText, hfPrint, hfNone - default is hfText)
+ [server] added property TfrxReportServer.WebServer
+ added property TfrxHTMLExport.EmptyLines
* e-mail export now inherits the attachment file name from exports file name
* update French resources
* update Danish resources
* update German resources
- fixed bug in TIFF export (monochrome)
- fixed bug in PDF export when Outline is empty and checked
- fixed large font issues
- some fixes for bar codes in PDF export
- add-in components fixes (AV when open some projects)
- fixed bug with preview (position of the page when resizing the window)
- fixed bug with RichText objects intersection in RTF export
- fixed bug with format of the float numbers in XLS export
- fixed bug with export of barcodes with zoom more than two
- fixed error when page number does not exist in page range in exports dialog
- [server] fixed bug with ampersand in query parameters
- fixed bug with XML export (XML Parsing Error)
- fixed bug with HideIfSingleDataRecord

version 3.22
-------------
+ added full TeeChart Pro support
+ added property TfrxHTMLExport.Centered in HTML export
+ added "Continuous" checkbox in RTF export dialog
+ added TfrxRTFExport.SuppressPageHeadersFooters property
+ added TfrxCheckBox.UncheckStyle property
+ added property TfrxGroupFooter.HideIfSingleDataRecord
+ added text shift on non-zero char spacing in PDF export
+ added Croatian resources
* update the main demo (ADO support, added new reports)
* added the object name to the error message in some cases
* TfrxGradientView is not exported in HTML, RTF, XLS formats
* preserve object names when working with clipboard
* improved HTML, RTF exports
* improved XML, Excel exports (thanks for Bali)
* increased timeout in E-Mail export
* update Danish resources
* update Portuguese resources 
- fixed bug with empty page in HTML export
- fixed IIF bug
- fixed bug with "ShowProgress := False" in XLS export
- fixed bug in XML export
- fixed error with reportsummary band 
- fixed memory leaks when script has errors
- fixed shift issues
- fixed brush style bsBDiagonal and bsFDiagonal in PDF export
- fixed bug with incorrect codepage of TfrxRichView in RTF export
- fixed bug with margins in PDF export
- fixed bug with blobfields in bds2006
- fixed bug with stretched images
- [server] fixed bug with reports cache
- [server] fixed bug with Idle time leak
- [server] minor bug fixes

Version 3.21
-------------
+ [server] added lot of properties in configuration file (config.xml)
+ [server] added CSV, BMP, GIF, TIFF output formats
+ [server] added caching of reports in memory
* [server] changed format of configuration file (important! see details in server_changes.txt)
* [server] property TfrxServer.Configuration is obsolete
* [server] updated server/service demo
* [server] modified log-writer, statistic, cache modules
- [server] lot of minor fixes
+ added TfrxHTMLExport.UseGif property
+ added unicode support in HTML, "Rich Text" (RTF) and XML exports
+ added TfrxXLSExport.SuppressPageHeadersFooters and TfrxXLSExport.SuppressPageHeadersFooters properties;
+ added TfrxReport.OnPreview event
+ added TfrxReport.OnPrintPage event
+ [FQB] property fqbCore.UsingQuotes added for support of quoted field names
+ added Slovak language resources
+ added clipping in the preview
+ added TfrxPreview.BackColor, FrameColor properties
+ added printer fonts to fontname combobox
+ added transparency/backcolor to rich object
+ added TfrxDesigner.OnInsertObject Event
* changes in the databand editor
* "Pictures" checkbox changed to combobox (none/jpeg/bmp/gif) in HTML export dialog 
* "Styles" checkbox  changed to "Continuous" in XLS and XML export dialog
* bcb2006 compatibility
* update Danish resources
* update Dutch resources 
* update Brazilian resources
- fixed bug with incorrect codepage detection for page navigator in HTML export
- fixed bug with incorrect export of EAN barcodes (digits beyond of border were croped)
- fixed incorrect page breaks in RTF export
- fixed shift problem
- fixed monochrome bitmaps stretching
- fixed TfrxDateEditControl
- fixed copying grouped objects
- fixed vband&overlay error
- fixed setting of printer parameters
- fixed KeepFooter + aggregate functions
- fixed TfrxADOTable.IndexFieldNames property
- fixed ado query parameters
- fixes in database/table/query wizard
- fixed bug with font charset in RTF export
- fixed preview painting bug
- fixed bug with rich when no printers installed
- fixed copies in dmp export
- fixed rtf expression parser
- fixed bug with mdi preview
- fixed bug with RTL reading brackets in PDF export
- fixed input chinese chars in dialog controls
- fixed shift behavior
- fixed bug with right align and non-zero charspacing in PDF export
- fixed bug with underline in HTML export
- fixed overlay+keeptogether bug
- fixed bug with bcb5 (cannot use function with parameters)
- fixed large font issues
- fixed html tags


version 3.20
-------------
+ improved RTF export
+ added handling font.charset (set to DEFAULT_CHARSET if you want unicode)
+ added EmptyLines property in XLS and XML export 
  (if set to 'false' then all empty lines is eliminated, good for export without 
  page breaks for output a solid table)
+ added ParagraphGap support in PDF export
+ enhanced speed and reduced output file size of PDF export
+ update German resources
+ update Turkish resources
+ added TfrxReport.OnBeforeConnect event
+ added ADO, IBX support in frf importer unit
+ added CommandTimeout property to ADO query
+ added pbExportQuick item in TfrxPreviewButtons set 
  (PDF and E-mail export buttons in Preview)
* AVG function now counts only non-Null values
* RichView object is now WYSIWYG
- [server] fixed bug with parameters in report refresh
- fixed bug in RTF export with font style attributes
- fixed bug with frames in PDF export
- fixed paper size bug
- fixed ParagraphGap in PDF export
- fixed stack overflow error with report summary band
- fixed error with dialog form
- fixed big with TProgressBar property out of range on exports of blank page in HTML
- fixed bug in PDF export with zero width/height of bitmap
- [FS] fixed OLE Ecxeption message
- fixed bug with checkbox object
- fixed bug with datatree window
- fixed error with chart datetime
- fixed bug with inspector window in debug mode
- fixed undo of password protected report
- fixed some dataset problems
- fixed ask save changes in designer
- fixed PDF export (font color clNone looks as clBlack) 


version 3.19
-------------
+ added separate frxTee package for TeeChart
+ added CJK Font support in PDF export
+ added frxHiButtons.pas unit (hi-color button images). Just add to your uses list.
+ added "Classes" tab to DataTree
+ added TfrxBarcodeView.WideBarRatio property
- multi-thread fixes
- fixed bug with cross+subreport
- fixed bug with CloseDatasource = True
- fixed bug in old-style cross
- fixed bug in XLS(OLE) export with extra long text line
- fixed bug in PDF export with non-TrueType fonts
- fixed memo.loadfromfile
- fixed bug with installer
- fixed print report title twice
- fixed startnewpage+reprintonnewpage
- fixed char spacing in PDF export
- fixed baClient align
- fixed dot-matrix (designer, engine)
- fixed app icon bug
- FS: multithread fix
- preview fixes
- frf importer fixes


version 3.18
-------------
* D2006 ready
+ added strikeout text support in HTML export
+ added char spacing support in PDF export
+ added support of BALTIC_CHARSET (windows-1257) in PDF export
+ added support TfrxShapeView diagonal lines in PDF export
+ added FRF import unit. To use it, simply include frx2xto30.pas into your "uses" list.
- fixed inplace editing of the Text object
- fixed bug with export to the monochrome TIFF format 
  (error with the MS Paint and Photo Editor) 
- fixed dbx components bug
- fixed paper bins selection
- fixed bugs in e-mail export (Lines and Signature properties, 
  bad attachment, bad address syntax with some smtp servers)
- fixes of the export filters interface
- fixed GIF export filter
- fixed bug with xp style (av when closing expr editor)
- fixed av when selecting sysmemo and memo
- fixed the default export file name in the "Save Dialog"
- fixed TfrxServerConfig.LoadFromFile



version 3.17
-------------
+ added Farsi language resources
+ added pdf and e-mail export buttons in preview toolbar
+ added popup menu in Preview
+ added full screen mode in Preview (F11 hot-key)
* improved PDF export filter
* restricted some properties of HTML and image export by e-mail
- [FQB] fixed for order by DESC of any field
- fixed bug with blank DefaultPath property in all exports
- fixed Null to OleStr bug
- fixed D5/WideStrings bug
- fixed bug with jscript/basicscript
- fixed ibo bug (cannot assign blob to TWideStrings)
- fixed picture bug (error if blob is not valid)
- fixed Cut/Copy/Paste hotkey actions in Object Inspector
- fixed bug with undo in password protected reports
- fixed bug with list of password protected reports in server
- fixed bug with Memo.Lines property
- IBO fixes



version 3.16
-------------
+ added unicode support in TfrxMemoView
+ added GIF format export TfrxGifExport
+ added e-mail export (SMTP) TfrxMailExport
+ added new text export filter TfrxSimpleTextExport
+ added CSV export filter TfrxCSVExport
+ case sensitivity in C++Script
+ added X axis type option to chart object
+ added ability to use [] instead of <> (like in FR2.5)
+ [FQB] joins between fields of the compatible types
+ added TfrxDesigner default settings (font, paper, rtl, script language). 
+ added TfrxDMPExport.OnTranslate event
* changed rules of export a rich-text objects
- fixed bug in server with single "pagenav" (Page Navigator) parameter
- fixed picture.url bug
- fixed bug in PDF export with horizontal/vertical lines
- [FQB] fixed 'Control has no parent window' error in Delphi 5
- fixed bug in crosstab (wrong row/column sizes)
- fixed baClient for page objects
- fixed memory leak in Server mode 
- fixed TFMTBCDField bug (wrong sum calculation)
- fixed bug with master-detail DBX



version 3.15
-------------
+ added new wizards (db connection, table, query)
+ added FlowTo property for TfrxDMPMemoView
+ added Bulgarian resources
+ added FibPlus support (you should install Source\FIB\frxFIBx.dpk, 
dclfrxFIBx.dpk packages manually)
+ added ability to composite prepared reports. Example:
frxReport1.PrepareReport;
frxReport2.PrepareReport;
frxReport1.PreviewPages.AddFrom(frxReport2);
frxReport1.ShowPreparedReport;
+ added UseFileCache, DefaultPath properties in all export filters
+ improved PDF, XLS export filters
* changed resources structure
* changed DBX components to work with bidirectional dataset
- fixed bug with copies collation
- fixed bug with shifting horizontal lines
- fixed DMPLineView.Align = baWidth behaviour
- fixed bug with TfrxDBLookupComboBox (incorrect work with field aliases)
- fixed bug with build list of avialable reports on the FastReport Server



version 3.14
-------------
+ added FastQueryBuilder (button in SQL editor window)
+ added TfrxOverlay.PrintOnTop property
+ added TfrxDMPCommand component to print ESC-sequences. Use Command property
to set sequence: DMPCommand1.Command := '#27#40' (alternate form '1B28')
+ added TfrxReport.OnRunDialogs script event. Use this event to handle
report dialogs manually
+ added Description property to all report components
* changed internal datasets behaviour, now they can be added to any report 
page without using dialogs
* changed internal datasets architecture (common class TfrxCustomDatabase,
QBuilder support)
- fixed bug with brush styles
- fixed bug in Report Server with fetch of report from the cache with 
equal variables
- fixed bug in XML export filter with fkNumber format of the memo


version 3.13
-------------
+ added "ExportNotPrintable" property in all export filters
+ added "Resolution", "SeparateFiles" properties in BMP, JPEG, TIFF export filters
+ improved TfrxHTTPClient RFC 2068 compatibility (when working with non-FastReport servers)
- fixed Outline bug in PDF export filter
- fixed RTL (Hebrew, Arabic language) bug in PDF export filter
- fixed resolution bug in TIFF export filter
- bug fixes


version 3.12
-------------
+ added TfrxReport.StoreInDFM property
+ added TfrxShapeView.Curve property
+ added TfrxReport.PreviewOptions.OutlineExpand property
+ added compatibility code in XLS export - TfrxXLSExport.FastExport property,
set FastExport := False if you have OLE error with Excel
+ added TfrxXLSExport.PageBreaks property
+ improved XLS, PDF, HTML exports 
- fixed OLE error when exporting to Excel
- fixed URLs and anchors feature in HTML export
- fixed bug with font widths in PDF export
- fixed bug PrintOnParent in exports 
(Enterprise)
+ added TfrxServerConfig.ReportsList property
+ added 'getvariable' URL parameter for query of internal server variables
+ added internal server variables SERVER_REPORTS_LIST, SERVER_REPORTS_HTML
+ added function TfrxReportClient.GetServerVariable(const VariableName: String): String;
+ improved TfrxReportServer performance
+ added NT service demo (see project \Demos\ClientServer\Service)
+ added online documentation in the Server demo
- fully rewritten Advanced Client demo (see project \Demos\ClientServer\Client\Advanced)
- changed reports in Server demo (see project \Demos\ClientServer\Server)
- changed html files in Server demo (see project \Demos\ClientServer\Server)
- bug fixes
- known bug: reports with TfrxRichView (RTF) don't work in Server mode when
server cache is on. 


version 3.11
-------------
+ added HTML tags support in PDF export
+ added Hebrew, Turkish and Arabic languages in the PDF export filter
+ added property TfrxPDFExport.Background (default = False)
+ added properties TfrxRTFExport.Creator and TfrxPDFExport.Creator
+ improved quality of the PDF export filter
+ password protected reports is now working in client/server mode
  (IMPORTANT: Do not use this feature in one time with the server authentification)
+ verbose output of the server errors in the HTML mode

- fixed name of the properties TfrxServerConnection.Proxy and TfrxServerConnection.ProxyPort 
  (press 'ignore' button on load prompt in yours projects for autofix form components)
- fixed clean of the report cache on TfrxReportServer.Stop method
- fixed background draw in HTML export filter in server mode
- many bug fixes


version 3.10
-------------
+ added Swiss, Portuguese, Latvian resources
+ added TfrxReport.OnEndDoc event
+ improved export filters
+ added outline in PDF export filter (TfrxPDFExport.Outline property)
+ added TfrxXLSExport.AsText property
+ added TfrxPDFExport.Author, TfrxPDFExport.Subject properties
+ added "Stream" property in all export filters
+ added TfrxReportServer.OnAfterBuildReport event handler
- bug fixes


version 3.09
-------------
- bug fixes


version 3.08
-------------
+ added TfrxMemoView.Clipped property
+ added TfrxReport.OnAfterPrintReport event
+ added baClient to Align property
+ added Danish, Chinese resources
+ now you can use national chars in the script identifier names
+ added TfrxPDFExport.PrintOptimized property
+ improved speed of the Excel export filter
+ added log rotate function in Client/Server version
- bug fixes


version 3.07
-------------
+ added Delphi2005 packages
+ added TfrxReport.Modified property
+ added TfrxReport.EngineOptions.DestroyForms property
+ added Polish, Swedish, Romanian resources
+ added expressions support to the Cross-tab object
* changes in aggregate functions call: <> symbols aren't needed anymore
* changes in IIF function: now it works like macro
- bug fixes


version 3.06
-------------
+ added BCB packages for FR3 Enterprise
+ added TfrxReportServer.OnGetVariables event handler
+ improved PDF export filter (underlines, languages)
+ improved RTF export filter (Word 2000 compatibility)
- bug fixes


version 3.05
-------------
+ added TfrxReport.ShowProgress property 
- bug fixes


version 3.04
-------------
+ added Taiwan, Italian, Slovene, Spanish, Catalon, Dutch resources
+ added "frxPBarcode.pas" unit for PSOFT BarcodeLibrary (http://www.psoft.sk)
+ added DayOf, MonthOf, YearOf functions
+ added "Multi-language wizard" for quick creation of the multi-language
  resource file
+ added TfrxReport.OldStyleProgress, OnProgressSTart, OnProgress, 
  OnProgressStop properties
- bug fixes


version 3.03
-------------
+ added Czech, Turkish resources
+ added TfrxUserDataset.Fields, TfrxUserDataset.OnGetValue properties
+ edition 1.01 of the documentation (page numbers added)
+ added TfrxDataBand.KeepHeader property
- bug fixes


version 3.02
-------------
+ added Serbian resources
+ added DelphiFastZLib library instead of zlib standard unit to avoid
  conflict between FR3 and JediVCL
+ added group/ungroup feature in the designer
+ added utility for quick recompiling FR packages
* changes in the Chart object - require to rebuild your reports that contain 
  the Chart object!
- bug fixes


version 3.01
-------------
+ added Ukrainian, Brazil, Hungarian, German, French resources
+ added TfrxReport.EnabledDatasets property
+ added TfrxCrossView.PlainCells property
+ added separate packages for DB and IBO
+ added separate FastScript packages for DB, BDE, IBX, ADO
* changes in RTF and PDF exports
- bug fixes


version 3.0
-------------
- initial release